#!/usr/bin/env python
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.support.ui import Select
from selenium.common.exceptions import NoSuchElementException
import unittest, time, re

'''
Andre Geracimian
Last Updated: August 21, 2014
This script will add a product (flyer) to cart and logout.
'''

class Trade(unittest.TestCase):
    def setUp(self):
        #Added these three lines
        desired_cap = {'browser': 'firefox', 'browser_version': '31.0', 'os': 'Windows', 'os_version': '8.1', 'resolution': '2048x1536'}

#Added this line to enable the Visual Logs tab.
        desired_cap['browserstack.debug'] = True
        desired_cap['build'] = 'v1.0'
        desired_cap['project'] = 'Trade'

#To run on BrowserStack's remote machines
        self.driver =     webdriver.Remote(command_executor='http://dianesalter1:xXz8vB9ft7A9zjksCyBm@hub.browserstack.com:80/wd/hub', desired_capabilities=desired_cap)

        self.driver.implicitly_wait(30)
        self.base_url = "https://trade.4over.com/"
        self.verificationErrors = []
        self.accept_next_alert = True
    
    def test_trade(self):
        driver = self.driver
    #    driver.set_window_size(2000, 2560)
        driver.get(self.base_url + "/")
        driver.find_element_by_xpath("//div[@id='login_top']/form/div/input").clear()
        driver.save_screenshot('screenshot.png')
        driver.find_element_by_xpath("//div[@id='login_top']/form/div/input").send_keys("andreg@4over.com")
        driver.save_screenshot('screenshot.png')
        driver.find_element_by_xpath("//div[@id='login_top']/form/div[2]/input").clear()
        driver.save_screenshot('screenshot.png')
        driver.find_element_by_xpath("//div[@id='login_top']/form/div[2]/input").send_keys("asdasd")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//div[@id='login_top']/form/div[3]/input").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//div[@id='categories']/ul/li[15]/a").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        Select(driver.find_element_by_xpath("//form[@id='list_view_filter']/fieldset/div/div[2]/select")).select_by_visible_text("100lb Gloss Cover")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        Select(driver.find_element_by_xpath("//form[@id='list_view_filter']/fieldset/div[4]/div[2]/select")).select_by_visible_text("4\" x 11\"")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("/html/body/div/div/div/div/div[3]/div[2]/div[1]/div[2]/div[6]/div[2]/div[9]/div[20]/div[1]/a").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        Select(driver.find_element_by_xpath("//span[@id='product_runsize']/select")).select_by_visible_text("1000")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//select[@id='runsize']/option[2]").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        Select(driver.find_element_by_xpath("//span[@id='product_color']/select")).select_by_visible_text("4:0")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//select[@id='color']/option[2]").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        Select(driver.find_element_by_xpath("//span[@id='product_tat']/select")).select_by_visible_text("2-4 Business Days")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//select[@id='tat']/option[3]").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//div[@id='job_details']/table/tbody/tr/td[3]/input").clear()
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("//div[@id='job_details']/table/tbody/tr/td[3]/input").send_keys("testjob")
        driver.save_screenshot('screenshot.png')
        time.sleep(1)
        driver.find_element_by_xpath("/html/body/div/div/div/div/div[3]/div[2]/div[1]/div[2]/div[6]/div[1]/form/div[8]/div/div/table/tbody/tr[3]/td[3]/span[1]/input").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(2)
        driver.find_element_by_xpath("//tr[@id='job_1_shiptodiv']/td[3]/span/input").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(2)
        driver.find_element_by_xpath("//div[@id='add_cart_job']/div[2]/input").click()
        driver.save_screenshot('screenshot.png')
        time.sleep(2)
        driver.find_element_by_xpath("//div[@id='scoop']/div[4]/div/a").click()
        driver.save_screenshot('screenshot.png')
        print "Succeed"
    
    def is_element_present(self, how, what):
        try: self.driver.find_element(by=how, value=what)
        except NoSuchElementException, e: return False
        return True
    
    def is_alert_present(self):
        try: self.driver.switch_to_alert()
        except NoAlertPresentException, e: return False
        return True
    
    def close_alert_and_get_its_text(self):
        try:
            alert = self.driver.switch_to_alert()
            alert_text = alert.text
            if self.accept_next_alert:
                alert.accept()
            else:
                alert.dismiss()
            return alert_text
        finally: self.accept_next_alert = True
    
    def tearDown(self):
        self.driver.quit()
        self.assertEqual([], self.verificationErrors)

if __name__ == "__main__":
    unittest.main()
